/*	Renegade Scripts.dll
	ArKa_47 Spy Chat Plugin
	Copyright 2020 ArKa_47, Shadow-Team

	This file is part of the Renegade scripts.dll
	The Renegade scripts.dll is free software; you can redistribute it and/or modify it under
	the terms of the GNU General Public License as published by the Free
	Software Foundation; either version 2, or (at your option) any later
	version. See the file COPYING for more details.
	In addition, an exemption is given to allow Run Time Dynamic Linking of this code with any closed source module that does not contain code covered by this licence.
	Only the source code to the module(s) containing the licenced code has to be released.
*/

#ifndef INCLUDE_SPYCHAT
#define INCLUDE_SPYCHAT

// Set MAX_PLAYERS to 128 as long as a better way exist to import server's max players
// #define MAX_PLAYERS 128
// solved:
#define MAX_PLAYERS (int)Get_Player_Limit() //  <--- this will crash the server during mem alloc, idk why (maybe the memory allocation for SpyList won't work correctly)
#define MAX_SPY 128 


// ------------------------------- AKSpyChatClass --------------------------------------------------------------------------
class ArKaSpyChatClass : public DAEventClass {
public:
	ArKaSpyChatClass() ;
	~ArKaSpyChatClass();

	virtual bool Chat_Event(cPlayer* Player, TextMessageEnum Type, const wchar_t* Message, int ReceiverID);
	virtual void Timer_Expired(int Number, unsigned int Data);
	virtual void Game_Over_Event();
	
	virtual void ScanSpies(); // Kinda useless at the moment
	bool Get_Is_Visible(int);
	bool Get_Is_Visible(GameObject*);
	void Add_To_Spylist(int PlayerId);
	void Delete_From_Spylist(int PlayerId);

		// the boolean SpyList
	bool SpyList[MAX_SPY];

		// amount of active spies in game
	int SpyCount;
};

#endif
